package ellightemu;

import com.sonycsl.echo.eoj.device.housingfacilities.GeneralLighting;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

public class MyLighting extends GeneralLighting {
    byte[] mStatus = {0x31};
    byte[] mMode = {0x41};
    byte[] mLocation = {0x00};
    byte[] mVersion = {0x01, 0x01, 0x61, 0x00};
    byte[] mFaultStatus = {0x42};
    byte[] mManufacturerCode = {0x00, 0x00, 0x00};

    @Override
    protected boolean setOperationStatus(byte[] edt) {
        try {
            if (edt[0] == 0x30)
                sendMessage(1, true);
            else if (edt[0] == 0x31)
                sendMessage(1, false);
            mStatus[0] = edt[0];
            inform().reqInformOperationStatus().send();
        } catch (IOException ex) {
            Logger.getLogger(MyLighting.class.getName()).log(Level.SEVERE, null, ex);
        }
        return true;
    }

    @Override
    protected byte[] getOperationStatus() {
        return mStatus;
    }

    @Override
    protected boolean setLightingModeSetting(byte[] edt) {
        mMode[0] = edt[0];

        try {
            inform().reqInformLightingModeSetting().send();
        } catch (IOException ex) {
            Logger.getLogger(MyLighting.class.getName()).log(Level.SEVERE,
                                                             null, ex);
        }
        return true;
    }

    @Override
    protected byte[] getLightingModeSetting() {
        return mMode;
    }

    @Override
    protected boolean setInstallationLocation(byte[] edt) {
        mLocation[0] = edt[0];

        try {
            inform().reqInformInstallationLocation().send();
        } catch (IOException ex) {
            Logger.getLogger(MyLighting.class.getName()).log(Level.SEVERE,
                                                             null, ex);
        }
        return true;
    }

    @Override
    protected byte[] getInstallationLocation() {
        return mLocation;
    }

    @Override
    protected byte[] getStandardVersionInformation() {
        return mVersion;
    }

    @Override
    protected byte[] getFaultStatus() {
        return mFaultStatus;
    }

    @Override
    protected byte[] getManufacturerCode() {
        return mManufacturerCode;
    }

    public static void sendMessage(int id, boolean on) throws IOException {
        InetSocketAddress socketAddress =
                new InetSocketAddress("localhost", EllightEmu.port);
        Socket socket = new Socket();
        socket.connect(socketAddress);
        String message = id + ": " + (on ? "on" : "off");
        PrintWriter writer = new PrintWriter(socket.getOutputStream(), true);
        writer.println(message);
        writer.flush();
    }
}
